<?php

require('includes/application_top.php');
require_once (DIR_FS_CATALOG_MODULES.'payment/constants.inc');
require_once (DIR_FS_CATALOG_MODULES.'payment/curl_util.class.inc');
require_once (DIR_FS_CATALOG_MODULES.'payment/xml_integrator.class.inc');
require_once (DIR_FS_CATALOG.'includes/log.php');

global $db;

$oID = zen_db_prepare_input($_GET['oID']);
$order_query = $db->Execute("select payment_module_code, currency, order_total from orders where orders_id = '" . zen_db_input($oID) . "'");

$payment_method = $order_query->fields['payment_module_code'];

if ($payment_method == 'xml_payolution_invoice' || $payment_method == 'xml_payolution_installment') {
	
	$preauth_id_query = $db->Execute("select pol_PREAUTHID from payment_" . $payment_method . " where pol_ORDERID = '" . zen_db_input($oID) . "'");
	$plugin_configuration_query = $db->Execute("select configuration_key, configuration_value from configuration where configuration_key like 'MODULE_PAYMENT_" . strtoupper($payment_method) . "_%'");
	while (!$plugin_configuration_query->EOF) {
		$key = substr($plugin_configuration_query->fields['configuration_key'], strlen($payment_method) + 16);
		$plugin_configuration[$key] = $plugin_configuration_query->fields['configuration_value'];
		$plugin_configuration_query->MoveNext();
	}
	
	$request_parameters = new xml_integrator();
	$request_parameters->security_sender = $plugin_configuration['SECURITY_SENDER'];
	$request_parameters->mode = $plugin_configuration['MODE'];
	$request_parameters->transaction_channel = $plugin_configuration['TRANSACTION_CHANNEL'];
	$request_parameters->user_login = $plugin_configuration['USER_LOGIN'];
	$request_parameters->user_pwd = $plugin_configuration['USER_PWD'];
	$request_parameters->identification_transaction = $oID;
	$request_parameters->identification_reference = $preauth_id_query->fields['pol_PREAUTHID'];
	$request_parameters->payment_code = 'VA.CP';
	$request_parameters->payment_presentation_amount = $order_query->fields['order_total'];
	$request_parameters->payment_presentation_currency = $order_query->fields['currency'];
	$request_parameters->payment_presentation_usage = PRESENTATION_USAGE . " " . $oID;
	$xml_string = $request_parameters->marshall();

	$response = curl_util::send_xml($plugin_configuration['CTPE_URL'], $xml_string);
	if ($response != false) {
		$response_parameters = new SimpleXMLELement($response);
		$result = $response_parameters->xpath("/Response/Transaction/Processing/Result");
		$message = $response_parameters->xpath("/Response/Transaction/Processing/Return");
	}
	else {
		$result = array('NOK');
		$message = array('No XML response');
	}
	
	$db->Execute("update payment_" . $payment_method . " set pol_CAPTURE_RESULT = '" . zen_db_input($result[0]) . "', pol_CAPTURE_MESSAGE = '" . zen_db_input($message[0]) . "' where pol_ORDERID = '" . zen_db_input($oID) . "'");
} 

zen_redirect(zen_href_link('orders.php', zen_get_all_get_params(array())));

?>
